;
; System equates
;
; OS EQUATES
; ----------
; 
; Syntax:
; Use '=' for addresses
; and '<' for read addresses (ex: KBCODE)
; and '>' for write addresses (ex: STIMER)
; and '#' for values
; 
; IO EQUATES
; 
ICHID       = $0000
ICDNO       = $0001
ICCOM       = $0002
ICSTA       = $0003
ICBAL       = $0004
ICBAH       = $0005
ICPTL       = $0006
ICPTH       = $0007
ICBLL       = $0008
ICBLH       = $0009
ICAX1       = $000A
ICAX2       = $000B
ICAX3       = $000C
ICAX4       = $000D
ICAX5       = $000E
ICAX6       = $000F
; 
; DISPLAY LIST EQUATES
; 
ADLI        = $0080
AVB         = $0040
ALMS        = $0040
AVSCR       = $0020
AHSCR       = $0010
AJMP        = $0001
AEMPTY1     = $0000
AEMPTY2     = $0010
AEMPTY3     = $0020
AEMPTY4     = $0030
AEMPTY5     = $0040
AEMPTY6     = $0050
AEMPTY7     = $0060
AEMPTY8     = $0070
; 
; OS VARIABLES FOR XL/XE
; 
; PAGE 0
; 
NGFLAG      = $0001
CASINI      = $0002
RAMLO       = $0004
TRAMSZ      = $0006
CMCMD       = $0007
WARMST      = $0008
BOOT        = $0009
DOSVEC      = $000A
DOSINI      = $000C
APPMHI      = $000E
POKMSK      = $0010
BRKKEY      = $0011
RTCLOK      = $0012
BUFADR      = $0015
ICCOMT      = $0017
DSKFMS      = $0018
DSKUTL      = $001A
ABUFPT      = $001C
ICHIDZ      = $0020
ICDNOZ      = $0021
ICCOMZ      = $0022
ICSTAZ      = $0023
ICBALZ      = $0024
ICBAHZ      = $0025
ICPTLZ      = $0026
ICPTHZ      = $0027
ICBLLZ      = $0028
ICBLHZ      = $0029
ICAX1Z      = $002A
ICAX2Z      = $002B
ICAX3Z      = $002C
ICAX4Z      = $002D
ICAX5Z      = $002E
ICAX6Z      = $002F
STATUS      = $0030
CHKSUM      = $0031
BUFRLO      = $0032
BUFRHI      = $0033
BFENLO      = $0034
BFENHI      = $0035
LTEMP       = $0036
BUFRFL      = $0038
RECVDN      = $0039
XMTDON      = $003A
CHKSNT      = $003B
NOCKSM      = $003C
BPTR        = $003D
FTYPE       = $003E
FEOF        = $003F
FREQ        = $0040
SOUNDR      = $0041
CRITIC      = $0042
FMSZPG      = $0043
ZCHAIN      = $004A
DSTAT       = $004C
ATRACT      = $004D
DRKMSK      = $004E
COLRSH      = $004F
TEMP        = $0050
HOLD1       = $0051
LMARGN      = $0052
RMARGN      = $0053
ROWCRS      = $0054
COLCRS      = $0055
DINDEX      = $0057
SAVMSC      = $0058
OLDROW      = $005A
OLDCOL      = $005B
OLDCHR      = $005D
OLDADR      = $005E
FKDEF       = $0060
PALNTS      = $0062
LOGCOL      = $0063
ADRESS      = $0064
MLTTMP      = $0066
SAVADR      = $0068
RAMTOP      = $006A
BUFCNT      = $006B
BUFSTR      = $006C
BITMSK      = $006E
SHFAMT      = $006F
ROWAC       = $0070
COLAC       = $0072
ENDPT       = $0074
DELTAR      = $0076
DELTAC      = $0077
KEYDEF      = $0079
SWPFLG      = $007B
HOLDCH      = $007C
INSDAT      = $007D
COUNTR      = $007E
LOMEM       = $0080
; 
; PAGE 2
; 
VDSLST      = $0200
VPRCED      = $0202
VINTER      = $0204
VBREAK      = $0206
VKEYBD      = $0208
VSERIN      = $020A
VSEROR      = $020C
VSEROC      = $020E
VTIMR1      = $0210
VTIMR2      = $0212
VTIMR4      = $0214
VIMIRQ      = $0216
CDTMV1      = $0218
CDTMV2      = $021A
CDTMV3      = $021C
CDTMV4      = $021E
CDTMV5      = $0220
VVBLKI      = $0222
VVBLKD      = $0224
CDTMA1      = $0226
CDTMA2      = $0228
CDTMF3      = $022A
SRTIMR      = $022B
CDTMF4      = $022C
INTEMP      = $022D
CDTMF5      = $022E
SDMCTL      = $022F
SDLSTL      = $0230
SDLSTH      = $0231
SSKCTL      = $0232
SPARE       = $0233
LPENH       = $0234
LPENV       = $0235
BRKKY       = $0236
VPIRQ       = $0238
CDEVIC      = $023A
CCOMND      = $023B
CAUX1       = $023C
CAUX2       = $023D
TMPSIO      = $023E
ERRFLG      = $023F
DFLAGS      = $0240
DBSECT      = $0241
BOOTAD      = $0242
COLDST      = $0244
RECLEN      = $0245
DSKTIM      = $0246
PDVMSK      = $0247
SHPDVS      = $0248
PDMSK       = $0249
RELADR      = $024A
PPTMPA      = $024C
PPTMPX      = $024D
CHSALT      = $026B
VSFLAG      = $026C
KEYDIS      = $026D
FINE        = $026E
GPRIOR      = $026F
PADDL0      = $0270
PADDL1      = $0271
PADDL2      = $0272
PADDL3      = $0273
PADDL4      = $0274
PADDL5      = $0275
PADDL6      = $0276
PADDL7      = $0277
STICK0      = $0278
STICK1      = $0279
STICK2      = $027A
STICK3      = $027B
PTRIG0      = $027C
PTRIG1      = $027D
PTRIG2      = $027E
PTRIG3      = $027F
PTRIG4      = $0280
PTRIG5      = $0281
PTRIG6      = $0282
PTRIG7      = $0283
STRIG0      = $0284
STRIG1      = $0285
STRIG2      = $0286
STRIG3      = $0287
HIBYTE      = $0288
WMODE       = $0289
BLIM        = $028A
IMASK       = $028B
JVECK       = $028C
NEWADR      = $028E
TXTROW      = $0290
TXTCOL      = $0291
TINDEX      = $0293
TXTMSC      = $0294
TXTOLD      = $0296
CRETRY      = $029C
HOLD3       = $029D
SUBTMP      = $029E
HOLD2       = $029F
DMASK       = $02A0
TMPLBT      = $02A1
ESCFLG      = $02A2
TABMAP      = $02A3
LOGMAP      = $02B2
INVFLG      = $02B6
FILFLG      = $02B7
TMPROW      = $02B8
TMPCOL      = $02B9
SCRFLG      = $02BB
HOLD4       = $02BC
DRETRY      = $02BD
SHFLOC      = $02BE
BOTSCR      = $02BF
PCOLR0      = $02C0
PCOLR1      = $02C1
PCOLR2      = $02C2
PCOLR3      = $02C3
COLOR0      = $02C4
COLOR1      = $02C5
COLOR2      = $02C6
COLOR3      = $02C7
COLOR4      = $02C8
RUNADR      = $02C9
HIUSED      = $02CB
ZHIUSE      = $02CD
GBYTEA      = $02CF
LOADAD      = $02D1
ZLOADA      = $02D3
DSCTLN      = $02D5
ACMISR      = $02D7
KRPDER      = $02D9
KEYREP      = $02DA
NOCLIK      = $02DB
HELPFG      = $02DC
DMASAV      = $02DD
PBPNT       = $02DE
PBUFSZ      = $02DF
RUNAD       = $02E0
INITAD      = $02E2
RAMSIZ      = $02E4
MEMTOP      = $02E5
MEMLO       = $02E7
HNDLOD      = $02E9
DVSTAT      = $02EA
CBAUDL      = $02EE
CBAUDH      = $02EF
CRSINH      = $02F0
KEYDEL      = $02F1
CH1         = $02F2
CHACT       = $02F3
CHBAS       = $02F4
NEWROW      = $02F5
NEWCOL      = $02F6
ROWINC      = $02F8
COLINC      = $02F9
CHAR        = $02FA
ATACHR      = $02FB
CH          = $02FC
FILDAT      = $02FD
DSPFLG      = $02FE
SSFLAG      = $02FF
; 
; PAGE 3
; 
DDEVIC      = $0300
DUNIT       = $0301
DCOMND      = $0302
DSTATS      = $0303
DBUFLO      = $0304
DBUFHI      = $0305
DTIMLO      = $0306
DUNUSE      = $0307
DBYTLO      = $0308
DBYTHI      = $0309
DAUX1       = $030A
DAUX2       = $030B
TIMER1      = $030C
ADDCOR      = $030E
CASFLG      = $030F
TIMER2      = $0310
TEMP1       = $0312
TEMP2       = $0314
TEMP3       = $0315
SAVIO       = $0316
TIMFLG      = $0317
STACKP      = $0318
TSTAT       = $0319
HATABS      = $031A
PUPBT1      = $033D
PUPBT2      = $033E
PUPBT3      = $033F
IOCB0       = $0340
IOCB1       = $0350
IOCB2       = $0360
IOCB3       = $0370
IOCB4       = $0380
IOCB5       = $0390
IOCB6       = $03A0
IOCB7       = $03B0
PRNBUF      = $03C0
SUPERF      = $03E8
CKEY        = $03E9
CASSBT      = $03EA
CARTCK      = $03EB
DERRF       = $03EC
ACMVAR      = $03ED
BASICF      = $03F8
MINTLK      = $03F9
GINTLK      = $03FA
CHLINK      = $03FB
CASBUF      = $03FD
; 
; HARDWARE REGISTERS
; 
; GTIA
; 
M0PF        = $D000
HPOSP0      = $D000
M1PF        = $D001
HPOSP1      = $D001
M2PF        = $D002
HPOSP2      = $D002
M3PF        = $D003
HPOSP3      = $D003
P0PF        = $D004
HPOSM0      = $D004
P1PF        = $D005
HPOSM1      = $D005
P2PF        = $D006
HPOSM2      = $D006
P3PF        = $D007
HPOSM3      = $D007
M0PL        = $D008
SIZEP0      = $D008
M1PL        = $D009
SIZEP1      = $D009
M2PL        = $D00A
SIZEP2      = $D00A
M3PL        = $D00B
SIZEP3      = $D00B
P0PL        = $D00C
SIZEM       = $D00C
P1PL        = $D00D
GRAFP0      = $D00D
P2PL        = $D00E
GRAFP1      = $D00E
P3PL        = $D00F
GRAFP2      = $D00F
TRIG0       = $D010
GRAFP3      = $D010
TRIG1       = $D011
GRAFM       = $D011
TRIG2       = $D012
COLPM0      = $D012
TRIG3       = $D013
COLPM1      = $D013
PAL         = $D014
COLPM2      = $D014
COLPM3      = $D015
COLPF0      = $D016
COLPF1      = $D017
COLPF2      = $D018
COLPF3      = $D019
COLBK       = $D01A
PRIOR       = $D01B
VDELAY      = $D01C
GRACTL      = $D01D
HITCLR      = $D01E
CONSOL      = $D01F
; 
; POKEY
; 
POT0        = $D200
AUDF1       = $D200
POT1        = $D201
AUDC1       = $D201
POT2        = $D202
AUDF2       = $D202
POT3        = $D203
AUDC2       = $D203
POT4        = $D204
AUDF3       = $D204
POT5        = $D205
AUDC3       = $D205
POT6        = $D206
AUDF4       = $D206
POT7        = $D207
AUDC4       = $D207
ALLPOT      = $D208
AUDCTL      = $D208
KBCODE      = $D209
STIMER      = $D209
RANDOM      = $D20A
SKREST      = $D20A
POTGO       = $D20B
SERIN       = $D20D
SEROUT      = $D20D
IRQST       = $D20E
IRQEN       = $D20E
SKSTAT      = $D20F
SKCTL       = $D20F
; 
; PIA
; 
PORTA       = $D300
PORTB       = $D301
PACTL       = $D302
PBCTL       = $D303
; 
; ANTIC
; 
DMACLT      = $D400
CHACTL      = $D401
DLISTL      = $D402
DLISTH      = $D403
HSCROL      = $D404
VSCROL      = $D405
PMBASE      = $D407
CHBASE      = $D409
WSYNC       = $D40A
VCOUNT      = $D40B
PENH        = $D40C
PENV        = $D40D
NMIEN       = $D40E
NMIST       = $D40F
NMIRES      = $D40F
; 
; FLOATING POINT ROUTINES
; 
AFP         = $D800
FASC        = $D8E6
IFP         = $D9AA
FPI         = $D9D2
ZFR0        = $DA44
ZF1         = $DA46
FSUB        = $DA60
FADD        = $DA66
FMUL        = $DADB
FDIV        = $DB28
PLYEVL      = $DD40
FLD0R       = $DD89
FLD0P       = $DD8D
FLD1R       = $DD98
FLD1P       = $DD9C
FSTOR       = $DDA7
FSTOP       = $DDAB
FMOVE       = $DDB6
EXP         = $DDC0
EXP10       = $DDCC
LOG         = $DECD
LOG10       = $DED1
; 
; ROM VECTORS
; 
DSKINV      = $E453
CIOV        = $E456
SIOV        = $E459
SETVBV      = $E45C
SYSVBV      = $E45F
XITVBV      = $E462
SIOINV      = $E465
SENDEV      = $E468
INTINV      = $E46B
CIOINV      = $E46E
SELFSV      = $E471
WARMSV      = $E474
COLDSV      = $E477
RBLOKV      = $E47A
CSOPIV      = $E47D
PUPDIV      = $E480
SELFTSV     = $E483
PENTV       = $E486
PHUNLV      = $E489
PHINIV      = $E48C
GPDVV       = $E48F
;
; Code equates
;
L0082       = $0082
L0083       = $0083
L0084       = $0084
L0085       = $0085
L0086       = $0086
L0087       = $0087
L0088       = $0088
L0089       = $0089
L008A       = $008A
L008B       = $008B
L008C       = $008C
L008D       = $008D
L008F       = $008F
L0092       = $0092
L0093       = $0093
L0094       = $0094
L0095       = $0095
L0096       = $0096
L0097       = $0097
L0098       = $0098
L0099       = $0099
L009A       = $009A
L009B       = $009B
L009C       = $009C
L009E       = $009E
L009F       = $009F
L00A0       = $00A0
L00A1       = $00A1
L00A2       = $00A2
L0600       = $0600
L0601       = $0601
L0603       = $0603
L34FF       = $34FF
L47D2       = $47D2
;
; Start of code
;
            *= $3500
;
L3500       lda #$01               ; A9 01
            sta L34FF              ; 8D FF 34
            jsr L39E5              ; 20 E5 39

            ldx #$00               ; A2 00
            stx L008F              ; level number

            stx L009C              ; pills collected?
            stx AUDF1              ; 8E 00 D2
            ldx #$58               ; A2 58
            stx CHBAS              ; 8E F4 02
            jsr L3A01              ; 20 01 3A
            jsr L3A4A              ; 20 4A 3A

L351C       ldx #$20               ; A2 20
            stx LMARGN             ; 86 52
            ldx #$24               ; A2 24
            stx RMARGN             ; 86 53
            ldx #$15               ; A2 15
            stx ROWCRS             ; 86 54
            ldx #$20               ; A2 20
            stx COLCRS             ; 86 55
            ldx #$00               ; A2 00
            stx COLCRS+1           ; 86 56
;press start
            lda #$AA               ; A9 AA
            sta IOCB0+ICBAL        ; 8D 44 03
            lda #$3A               ; A9 3A
            sta IOCB0+ICBAH        ; 8D 45 03
;len
            lda #$0A               ; A9 0A
            sta IOCB0+ICBLL        ; 8D 48 03
            lda #$00               ; A9 00
            sta IOCB0+ICBLH        ; 8D 49 03
            jsr CIOV               ; 20 56 E4
L3547       lda CONSOL             ; AD 1F D0
            cmp #$06               ; C9 06
            bne L3547              ; D0 F9
            ldx #$15               ; A2 15
            stx ROWCRS             ; 86 54
            ldx #$20               ; A2 20
            stx COLCRS             ; 86 55
            lda #$B4               ; A9 B4
            sta IOCB0+ICBAL        ; 8D 44 03
            lda #$3A               ; space
            sta IOCB0+ICBAH        ; 8D 45 03
            lda #$0A               ; A9 0A
            sta IOCB0+ICBLL        ; 8D 48 03
            lda #$00               ; A9 00
            sta IOCB0+ICBLH        ; 8D 49 03
            jsr CIOV               ; 20 56 E4

            lda L34FF              ; AD FF 34
            cmp #$01               ; C9 01
            beq L358B              ; F0 17
            ldx #$00               ; A2 00
            stx L008F              ; 86 8F
            stx L009C              ; 86 9C
            stx AUDF1              ; 8E 00 D2
            jsr L39E5              ; 20 E5 39
            lda #$58               ; A9 58
            sta CHBAS              ; 8D F4 02
            jsr L3A01              ; 20 01 3A
            jsr L3A4A              ; 20 4A 3A
L358B       lda #$58               ; A9 58
            sta CHBAS              ; 8D F4 02
            lda #$00               ; A9 00
            sta L34FF              ; 8D FF 34

            clc                    ; LIVES
            lda #$55               ; A9 55
            adc SAVMSC             ; 65 58
            sta L0098              ; 85 98
            lda #$02               ; A9 02
            adc SAVMSC+1           ; 65 59
            sta L0099              ; 85 99

            clc                    ; LEVEL
            lda #$2C               ; A9 2C
            adc SAVMSC             ; 65 58
            sta L009A              ; 85 9A
            lda #$02               ; A9 02
            adc SAVMSC+1           ; 65 59
            sta L009B              ; 85 9B

            clc                    ; SCORE
            lda #$88               ; A9 88
            adc SAVMSC             ; 65 58
            sta L0086              ; 85 86
            lda #$01               ; A9 01
            adc SAVMSC+1           ; 65 59
            sta L0087              ; 85 87

            clc                    ; TIME
            lda SAVMSC             ; A5 58
            adc #$DC               ; 69 DC
            sta L00A1              ; 85 A1
            lda SAVMSC+1           ; A5 59
            adc #$01               ; 69 01
            sta L00A2              ; 85 A2

            ldx #$41               ; A2 41
            stx L009E              ; 86 9E
            ldx #$40               ; A2 40
            stx L009F              ; 86 9F

L35D1       ldy #$00               ; A0 00
            sty RTCLOK+1           ; 84 13
            sty RTCLOK+2           ; 84 14
            lda #$19               ; "9"
            sta (L00A1),Y          ; 91 A1
            iny                    ; C8
            lda #$10               ; "0"
            sta (L00A1),Y          ; 91 A1

            clc                    ; tail position
            lda SAVMSC             ; A5 58
            adc #$2B               ; 69 2B
            sta LOMEM              ; 85 80
            lda SAVMSC+1           ; A5 59
            adc #$00               ; 69 00
            sta LOMEM+1            ; 85 81

            clc                    ; head position
            lda SAVMSC             ; A5 58
            adc #$2D               ; 69 2D
            sta L0082              ; 85 82
            lda SAVMSC+1           ; A5 59
            adc #$00               ; 69 00
            sta L0083              ; 85 83

            ldx #$00               ; A2 00
            stx L008D              ; 86 8D
            ldx #$07               ; A2 07
            stx L008A              ; 86 8A
            ldx #$EF               ; A2 EF
            stx AUDC1              ; 8E 01 D2
            lda #$1F               ; A9 1F
            sta L00A0              ; 85 A0
            ldy #$00               ; A0 00
            sta (LOMEM),Y          ; 91 80
            lda #$0C               ; A9 0C
            iny                    ; C8
            sta (LOMEM),Y          ; 91 80
            iny                    ; C8
            lda #$0D               ; A9 0D
            sta (LOMEM),Y          ; 91 80
L3619       ldy #$01               ; A0 01
            lda #$12               ; A9 12
            sec                    ; 38
            sbc RTCLOK+1           ; E5 13
            sta L0600              ; 8D 00 06
            and #$01               ; 29 01
            cmp #$01               ; C9 01
            beq L3630              ; F0 07
            lda #$10               ; A9 10
            sta (L00A1),Y          ; 91 A1
            jmp L3634              ; 4C 34 36
L3630       lda #$15               ; A9 15
            sta (L00A1),Y          ; 91 A1
L3634       lda L0600              ; AD 00 06
            lsr A                  ; 4A
            clc                    ; 18
            adc #$10               ; 69 10
            ldy #$00               ; A0 00
            sta (L00A1),Y          ; 91 A1
            lda L0600              ; AD 00 06
            cmp #$00               ; C9 00
            bne L3649              ; D0 03
            jmp L38B8              ; 4C B8 38
L3649       ldx #$00               ; A2 00
            stx ATRACT             ; 86 4D
            ldx L009E              ; A6 9E
            jsr L39D8              ; 20 D8 39
            lda #$00               ; A9 00
            sta AUDF1              ; 8D 00 D2
            lda STICK0             ; AD 78 02
            sta L008C              ; 85 8C

;check joystick
            ldx #$00               ; A2 00
L365E       cmp L3A82,X            ; DD 82 3A
            beq L366B              ; F0 08
            inx                    ; E8
            cpx #$04               ; E0 04
            bne L365E              ; D0 F6
            jmp L3672              ; 4C 72 36
L366B       lda L008A              ; A5 8A
            sta L008C              ; 85 8C
            jmp L3684              ; 4C 84 36

L3672       cmp L008A              ; C5 8A
            beq L367A              ; F0 04
            lda L008A              ; A5 8A
            sta L008B              ; 85 8B
L367A       lda L008C              ; A5 8C
            cmp #$0F               ; C9 0F
            beq L3684              ; F0 04
            lda L008C              ; A5 8C
            sta L008A              ; 85 8A
L3684       lda L008C              ; A5 8C
            cmp #$0F               ; C9 0F
            bne L368E              ; D0 04

            lda L008A              ; A5 8A
            sta L008C              ; 85 8C
L368E       lda L0082              ; A5 82
            sta L0092              ; 85 92
            lda L0083              ; A5 83
            sta L0093              ; 85 93
            lda L008C              ; A5 8C
            cmp #$0E               ; C9 0E
            beq L36AB              ; F0 0F
            cmp #$0D               ; C9 0D
            beq L36BB              ; F0 1B
            cmp #$0B               ; C9 0B
            beq L36CB              ; F0 27
            cmp #$07               ; C9 07
            beq L36DB              ; F0 33
            jmp L3619              ; 4C 19 36

L36AB       sec                    ; 38
            lda L0082              ; A5 82
            sbc #$28               ; E9 28
            sta L0082              ; 85 82
            lda L0083              ; A5 83
            sbc #$00               ; E9 00
            sta L0083              ; 85 83
            jmp L36E8              ; 4C E8 36
L36BB       clc                    ; 18
            lda L0082              ; A5 82
            adc #$28               ; 69 28
            sta L0082              ; 85 82
            lda L0083              ; A5 83
            adc #$00               ; 69 00
            sta L0083              ; 85 83
            jmp L36E8              ; 4C E8 36
L36CB       sec                    ; 38
            lda L0082              ; A5 82
            sbc #$01               ; E9 01
            sta L0082              ; 85 82
            lda L0083              ; A5 83
            sbc #$00               ; E9 00
            sta L0083              ; 85 83
            jmp L36E8              ; 4C E8 36
L36DB       clc                    ; 18
            lda L0082              ; A5 82
            adc #$01               ; 69 01
            sta L0082              ; 85 82
            lda L0083              ; A5 83
            adc #$00               ; 69 00
            sta L0083              ; 85 83
L36E8       ldx #$00               ; A2 00
            lda (L0082,X)          ; A1 82
            cmp #$0A               ; wall
            bne L36F3              ; D0 03
            jmp L3828              ; 4C 28 38

L36F3       cmp #$0B               ; square or pill
            bne L36FA              ; D0 03
            jmp L3708              ; 4C 08 37
L36FA       cmp #$0C               ; snake body
            bne L3701              ; D0 03
            jmp L38B8              ; 4C B8 38
L3701       cmp L00A0              ; C5 A0
            bne L3728              ; D0 23
            jmp L38B8              ; 4C B8 38

L3708       jsr L3736              ; 20 36 37
            lda #$50               ; A9 50
            sta AUDF1              ; 8D 00 D2
            jsr L391B              ; setup score
            lda L008F              ; level number
            and #$03               ; 29 03
            tay                    ; A8
            inc L009C              ; E6 9C
            lda L009C              ; A5 9C
            cmp L3A86,Y            ; #pills
            bne L3724              ; D0 03
            jmp L396B              ; 4C 6B 39

L3724       ldx #$01               ; A2 01
            stx L008D              ; 86 8D
L3728       jsr L3736              ; 20 36 37
            ldx L008D              ; A6 8D
            cpx #$00               ; E0 00
            beq L3741              ; F0 10
            dec L008D              ; C6 8D
            jmp L3619              ; 4C 19 36

L3736       ldy #$00               ; A0 00
            lda #$0C               ; body
            sta (L0092),Y          ; 91 92
            lda #$0D               ; snake head
            sta (L0082),Y          ; 91 82
            rts                    ; 60

L3741       sec                    ; 38
            lda LOMEM              ; A5 80
            sbc #$28               ; E9 28
            sta L0084              ; 85 84
            lda LOMEM+1            ; A5 81
            sbc #$00               ; E9 00
            sta L0085              ; 85 85
            ldy #$00               ; A0 00
            lda (L0084),Y          ; B1 84
            cmp #$0C               ; C9 0C
            bne L375E              ; D0 08

            ldx #$00               ; A2 00
            stx L0601              ; 8E 01 06

            jmp L378B              ; 4C 8B 37

L375E       ldy #$50               ; A0 50
            lda (L0084),Y          ; B1 84
            cmp #$0C               ; C9 0C
            bne L376E              ; D0 08
            ldx #$02               ; A2 02
            stx L0601              ; 8E 01 06
            jmp L378B              ; 4C 8B 37

L376E       ldy #$27               ; A0 27
            lda (L0084),Y          ; B1 84
            cmp #$0C               ; C9 0C
            bne L377E              ; D0 08
            ldx #$04               ; A2 04
            stx L0601              ; 8E 01 06
            jmp L378B              ; 4C 8B 37
L377E       ldy #$29               ; A0 29
            lda (L0084),Y          ; B1 84
            cmp #$0C               ; C9 0C
            bne L378B              ; D0 05
            ldx #$06               ; A2 06
            stx L0601              ; 8E 01 06
L378B       lda #$00               ; A9 00
            tax                    ; AA
            sta (LOMEM,X)          ; 81 80
            ldx L0601              ; AE 01 06
            lda L3A7A,X            ; BD 7A 3A
            sta L0096              ; 85 96
            inx                    ; E8
            lda L3A7A,X            ; BD 7A 3A
            sta L0097              ; 85 97
            jmp (L0096)            ; 6C 96 00
;37a1
            sec                    ; 38
            lda LOMEM              ; A5 80
            sbc #$28               ; E9 28
            sta LOMEM              ; 85 80
            lda LOMEM+1            ; A5 81
            sbc #$00               ; E9 00
            sta LOMEM+1            ; 85 81
            jmp L37E1              ; 4C E1 37
;37b1
            clc                    ; 18
            lda LOMEM              ; A5 80
            adc #$28               ; 69 28
            sta LOMEM              ; 85 80
            lda LOMEM+1            ; A5 81
            adc #$00               ; 69 00
            sta LOMEM+1            ; 85 81
            jmp L37E1              ; 4C E1 37
;37c1
            sec                    ; 38
            lda LOMEM              ; A5 80
            sbc #$01               ; E9 01
            sta LOMEM              ; 85 80
            lda LOMEM+1            ; A5 81
            sbc #$00               ; E9 00
            sta LOMEM+1            ; 85 81
            jmp L37E1              ; 4C E1 37
;37d1
            clc                    ; 18
            lda LOMEM              ; A5 80
            adc #$01               ; 69 01
            sta LOMEM              ; 85 80
            lda LOMEM+1            ; A5 81
            adc #$00               ; 69 00
            sta LOMEM+1            ; 85 81
            jmp L37E1              ; 4C E1 37
L37E1       sec                    ; 38
            lda LOMEM              ; A5 80
            sbc #$28               ; E9 28
            sta L0094              ; 85 94
            lda LOMEM+1            ; A5 81
            sbc #$00               ; E9 00
            sta L0095              ; 85 95
            ldy #$00               ; A0 00
            lda (L0094),Y          ; B1 94
            cmp #$0C               ; C9 0C
            bne L37FD              ; D0 07
            ldy #$1E               ; A0 1E
            sty L00A0              ; 84 A0
            jmp L381F              ; 4C 1F 38
L37FD       ldy #$27               ; A0 27
            lda (L0094),Y          ; B1 94
            cmp #$0C               ; C9 0C
            bne L380C              ; D0 07
            ldy #$1F               ; A0 1F
            sty L00A0              ; 84 A0
            jmp L381F              ; 4C 1F 38
L380C       ldy #$29               ; A0 29
            lda (L0094),Y          ; B1 94
            cmp #$0C               ; C9 0C
            bne L381B              ; D0 07
            ldy #$1F               ; A0 1F
            sty L00A0              ; 84 A0
            jmp L381F              ; 4C 1F 38
L381B       ldy #$1E               ; A0 1E
            sty L00A0              ; 84 A0
L381F       ldy #$00               ; A0 00
            lda L00A0              ; A5 A0
            sta (LOMEM),Y          ; 91 80
            jmp L3619              ; 4C 19 36
L3828       sec                    ; 38
            lda L0092              ; A5 92
            sbc #$28               ; E9 28
            sta L0084              ; 85 84
            lda L0093              ; A5 93
            sbc #$00               ; E9 00
            sta L0085              ; 85 85
            clc                    ; 18
            lda L0092              ; A5 92
            adc #$28               ; 69 28
            sta L0094              ; 85 94
            lda L0093              ; A5 93
            adc #$00               ; 69 00
            sta L0095              ; 85 95
            ldx #$00               ; A2 00
            lda (L0084,X)          ; A1 84
            cmp #$0A               ; C9 0A
            beq L3851              ; F0 07
            cmp #$0C               ; C9 0C
            beq L385A              ; F0 0C
            jmp L3863              ; 4C 63 38
L3851       lda (L0094,X)          ; A1 94
            cmp #$0C               ; C9 0C
            bne L3863              ; D0 0C
            jmp L389E              ; 4C 9E 38
L385A       lda (L0094,X)          ; A1 94
            cmp #$0A               ; C9 0A
            bne L3863              ; D0 03
            jmp L389E              ; 4C 9E 38
L3863       sec                    ; 38
            lda L0092              ; A5 92
            sbc #$01               ; E9 01
            sta L0084              ; 85 84
            lda L0093              ; A5 93
            sbc #$00               ; E9 00
            sta L0085              ; 85 85
            clc                    ; 18
            lda L0092              ; A5 92
            adc #$01               ; 69 01
            sta L0094              ; 85 94
            lda L0093              ; A5 93
            adc #$00               ; 69 00
            sta L0095              ; 85 95
            ldx #$00               ; A2 00
            lda (L0084,X)          ; A1 84
            cmp #$0A               ; C9 0A
            beq L388C              ; F0 07
            cmp #$0C               ; C9 0C
            beq L3895              ; F0 0C
            jmp L38A9              ; 4C A9 38
L388C       lda (L0094,X)          ; A1 94
            cmp #$0C               ; C9 0C
            beq L389E              ; F0 0C
            jmp L38A9              ; 4C A9 38
L3895       lda (L0094,X)          ; A1 94
            cmp #$0A               ; C9 0A
            beq L389E              ; F0 03
            jmp L38A9              ; 4C A9 38
L389E       ldx L0092              ; A6 92
            stx L0082              ; 86 82
            ldx L0093              ; A6 93
            stx L0083              ; 86 83
            jmp L3619              ; 4C 19 36
L38A9       ldx L008B              ; A6 8B
            stx L008C              ; 86 8C
            ldx L0092              ; A6 92
            stx L0082              ; 86 82
            ldx L0093              ; A6 93
            stx L0083              ; 86 83
            jmp L3672              ; 4C 72 36

L38B8       ldy #$00               ; A0 00

;dead
L38BA       ldx #$80               ; A2 80
            lda L3A9B,Y            ; B9 9B 3A
            sta AUDF1              ; 8D 00 D2
            tya                    ; 98
            pha                    ; 48
            jsr L39D8              ; 20 D8 39
            pla                    ; 68
            tay                    ; A8
            iny                    ; C8
            cpy #$0F               ; C0 0F
            bne L38BA              ; D0 EC
;life--
            ldy #$00               ; A0 00
            lda (L0098),Y          ; B1 98
            cmp #$10               ; C9 10
            bne L38D9              ; D0 03
            jmp L39D5              ; 4C D5 39
L38D9       sec                    ; 38
            sbc #$01               ; E9 01
            sta (L0098),Y          ; 91 98
            lda SAVMSC             ; A5 58
            sta L0094              ; 85 94
            lda SAVMSC+1           ; A5 59
            sta L0095              ; 85 95
;zero snake
L38E6       ldy #$00               ; A0 00
L38E8       lda (L0094),Y          ; B1 94
            cmp #$0C               ; snake body
            beq L38FD              ; F0 0F
            cmp #$0D               ; snake head
            beq L38FD              ; F0 0B
            cmp #$1E               ; snake tail rest
            beq L38FD              ; F0 07
            cmp #$1F               ; C9 1F
            beq L38FD              ; F0 03
            jmp L3901              ; 4C 01 39
L38FD       lda #$00               ; A9 00
            sta (L0094),Y          ; 91 94
L3901       iny                    ; C8
            cpy #$28               ; C0 28
            bne L38E8              ; D0 E2
            clc                    ; 18
            lda #$28               ; A9 28
            adc L0094              ; 65 94
            sta L0094              ; 85 94
            lda #$00               ; A9 00
            adc L0095              ; 65 95
            sta L0095              ; 85 95
            inx                    ; E8
            cpx #$18               ; E0 18
            bne L38E6              ; D0 CE

            jmp L35D1              ; 4C D1 35
;------------------------------------------------score++
L391B       ldy #$03               ; A0 03
            lda (L0086),Y          ; B1 86
            cmp #$19               ; "9"
            beq L3929              ; F0 06
            clc                    ; 18
            adc #$01               ; 69 01
            sta (L0086),Y          ; 91 86
            rts                    ; 60

L3929       lda #$10               ; A9 10
            sta (L0086),Y          ; 91 86
            ldy #$02               ; A0 02
            lda (L0086),Y          ; B1 86
            cmp #$19               ; C9 19
            beq L393B              ; F0 06
            clc                    ; 18
            adc #$01               ; 69 01
            sta (L0086),Y          ; 91 86
            rts                    ; 60

L393B       lda #$10               ; A9 10
            sta (L0086),Y          ; 91 86
L393F       ldy #$01               ; A0 01
            lda (L0086),Y          ; B1 86
            cmp #$19               ; C9 19
            beq L394D              ; F0 06
            clc                    ; 18
            adc #$01               ; 69 01
            sta (L0086),Y          ; 91 86
            rts                    ; 60
L394D       lda #$10               ; A9 10
            sta (L0086),Y          ; 91 86
            ldy #$00               ; A0 00
            lda (L0098),Y          ; life++ if score>99990
            clc                    ; 18
            adc #$01               ; 69 01
            sta (L0098),Y          ; 91 98
            lda (L0086),Y          ; B1 86
            cmp #$19               ; C9 19
            beq L3966              ; F0 06
            clc                    ; 18
            adc #$01               ; 69 01
            sta (L0086),Y          ; 91 86
            rts                    ; 60
;------------------------------------------------
L3966       lda #$10               ; A9 10
            sta (L0086),Y          ; 91 86
            rts                    ; 60

L396B       ldy #$00               ; A0 00
            sec                    ; 38
            lda L009E              ; A5 9E
            sbc #$04               ; E9 04
            cmp #$0D               ; C9 0D
            beq L3978              ; F0 02
            sta L009E              ; 85 9E
L3978       ldx #$80               ; A2 80
            lda L3A8A,Y            ; B9 8A 3A
            sta AUDF1              ; 8D 00 D2
            tya                    ; 98
            pha                    ; 48
            jsr L39D8              ; 20 D8 39
            pla                    ; 68
            tay                    ; A8
            iny                    ; C8
            cpy #$11               ; C0 11
            bne L3978              ; D0 EC
            inc L008F              ; E6 8F
            ldx #$00               ; A2 00
            stx L009C              ; 86 9C
            ldy #$02               ; A0 02
            lda (L009A),Y          ; B1 9A
            cmp #$19               ; C9 19
            beq L39A2              ; F0 08
            clc                    ; 18
            adc #$01               ; 69 01
            sta (L009A),Y          ; 91 9A
            jmp L39CC              ; 4C CC 39
L39A2       lda #$10               ; A9 10
            sta (L009A),Y          ; 91 9A
            ldy #$01               ; A0 01
            lda (L009A),Y          ; B1 9A
            cmp #$19               ; C9 19
            beq L39B6              ; F0 08
            clc                    ; 18
            adc #$01               ; 69 01
            sta (L009A),Y          ; 91 9A
            jmp L39CC              ; 4C CC 39
L39B6       lda #$10               ; A9 10
            sta (L009A),Y          ; 91 9A
            ldy #$00               ; A0 00
            lda (L009A),Y          ; B1 9A
            cmp #$19               ; C9 19
            beq L39C8              ; F0 06
            clc                    ; 18
            sta (L009A),Y          ; 91 9A
            jmp L39CC              ; 4C CC 39
L39C8       lda #$10               ; A9 10
            sta (L009A),Y          ; 91 9A
L39CC       jsr L393F              ; 20 3F 39
            jsr L3A4A              ; 20 4A 3A
            jmp L35D1              ; 4C D1 35
L39D5       jmp L351C              ; 4C 1C 35

L39D8       ldy #$FF               ; A0 FF
L39DA       dey                    ; 88
            cpy #$FF               ; C0 FF
            bne L39DA              ; D0 FB
            dex                    ; CA
            cpx #$00               ; E0 00
            bne L39D8              ; D0 F4
            rts                    ; 60

L39E5       lda SDLSTL             ; AD 30 02
            sta L0088              ; 85 88
            lda SDLSTH             ; AD 31 02
            sta L0089              ; 85 89
            lda #$44               ; A9 44
            ldy #$03               ; A0 03
            sta (L0088),Y          ; 91 88
            ldy #$06               ; A0 06
            lda #$04               ; A9 04
L39F9       sta (L0088),Y          ; 91 88
            iny                    ; C8
            cpy #$1D               ; C0 1D
            bne L39F9              ; D0 F9
            rts                    ; 60

L3A01       lda #$03               ; A9 03
            sta IOCB0+ICCOM        ; 8D 42 03
            lda #$08               ; A9 08
            sta IOCB0+ICAX1        ; 8D 4A 03
            lda #$00               ; A9 00
            sta IOCB0+ICAX2        ; 8D 4B 03
            lda #$47               ; A9 47
            sta IOCB0+ICBAL        ; 8D 44 03
            lda #$3A               ; A9 3A
            sta IOCB0+ICBAH        ; 8D 45 03
            jsr CIOV               ; 20 56 E4
            lda #$0B               ; A9 0B
            sta L0603              ; 8D 03 06
            sta IOCB0+ICCOM        ; 8D 42 03
            ldx #$1D               ; A2 1D
            stx LMARGN             ; 86 52
            ldx #$27               ; A2 27
            stx RMARGN             ; 86 53
            ldx #$00               ; A2 00
            lda #$D9               ; A9 D9
            sta IOCB0+ICBAL        ; 8D 44 03
            lda #$47               ; A9 47
            sta IOCB0+ICBAH        ; 8D 45 03
            lda #$E8               ; A9 E8
            sta IOCB0+ICBLL        ; 8D 48 03
            lda #$00               ; A9 00
            sta IOCB0+ICBLH        ; 8D 49 03
            jsr CIOV               ; 20 56 E4
            rts                    ; 60
;3A47
            .byte "E:"
            .byte $9B

L3A4A       ldx #$00               ; A2 00
            stx LMARGN             ; 86 52
            ldx #$1C               ; A2 1C
            stx RMARGN             ; 86 53
            ldx #$00               ; A2 00
            stx ROWCRS             ; 86 54
            stx COLCRS             ; 86 55
            stx COLCRS+1           ; 86 56
            lda L008F              ; A5 8F
            and #$03               ; 29 03
            asl A                  ; 0A
            tay                    ; A8
            lda L47D1,Y            ; B9 D1 47
            sta IOCB0+ICBAL        ; 8D 44 03
            lda L47D2,Y            ; B9 D2 47
            sta IOCB0+ICBAH        ; 8D 45 03
            lda #$9B               ; A9 9B
            sta IOCB0+ICBLL        ; 8D 48 03
            lda #$02               ; A9 02
            sta IOCB0+ICBLH        ; 8D 49 03
            jsr CIOV               ; 20 56 E4
            rts                    ; 60
L3A7A       lda (LTEMP+1,X)        ; A1 37
            lda (LTEMP+1),Y        ; B1 37
            cmp (LTEMP+1,X)        ; C1 37
            cmp (LTEMP+1),Y        ; D1 37

;joystick values
L3A82       ora TRAMSZ             ; 05 06
            ora #$0A               ; 09 0A

;pills amount
L3A86       ror A                  ; 6A
            pla                    ; 68
            ror A                  ; 6A
            .byte $69

;sound dump
L3A8A       .byte $00,$3C,$35,$32,$2F,$3C,$35,$2F
            .byte $2F,$40,$35,$35,$3C,$3C,$3C,$3C
            .byte $00
;sound dump dead
L3A9B       .byte $00,$C8,$C8,$00,$DC,$DC,$00,$F0
            .byte $F0,$00,$FF,$FF,$FF,$FF,$00
;3aaa
            .byte "PRESSSTART          "
;
            *= $5800
;
            .byte $00,$00,$00,$00,$00,$00,$00,$00
            .byte $00,$0C,$0C,$0C,$0C,$00,$0C,$00
            .byte $00,$33,$33,$33,$00,$00,$00,$00
            .byte $00,$33,$3F,$33,$33,$3F,$33,$00
            .byte $0C,$3F,$30,$3F,$03,$3F,$0C,$00
            .byte $00,$33,$03,$0C,$0C,$30,$33,$00
            .byte $0C,$33,$33,$33,$CC,$CC,$CC,$33
            .byte $00,$0C,$0C,$0C,$00,$00,$00,$00
            .byte $00,$0F,$0C,$30,$30,$0C,$0F,$00
            .byte $00,$3C,$0C,$03,$03,$0C,$3C,$00
            .byte $11,$44,$11,$44,$11,$44,$11,$44
            .byte $00,$00,$00,$28,$28,$28,$00,$00
            .byte $3C,$FF,$FF,$FF,$FF,$FF,$FF,$3C
            .byte $3C,$FF,$D7,$D7,$D7,$D7,$FF,$3C
            .byte $00,$00,$00,$00,$00,$0C,$0C,$00
            .byte $00,$03,$03,$0C,$0C,$30,$30,$00
            .byte $00,$3F,$33,$33,$33,$33,$3F,$00
            .byte $00,$0C,$3C,$0C,$0C,$0C,$3F,$00
            .byte $00,$3F,$33,$03,$3F,$30,$3F,$00
            .byte $00,$3F,$03,$3F,$03,$03,$3F,$00
            .byte $00,$33,$33,$3F,$03,$03,$03,$00
            .byte $00,$3F,$30,$3C,$03,$03,$3C,$00
            .byte $00,$3F,$30,$3F,$33,$33,$3F,$00
            .byte $00,$3F,$03,$03,$0C,$30,$30,$00
            .byte $00,$3F,$33,$3F,$33,$33,$3F,$00
            .byte $00,$3F,$33,$3F,$03,$03,$03,$00
            .byte $00,$00,$0C,$0C,$00,$0C,$0C,$00
            .byte $00,$00,$0C,$0C,$00,$0C,$0C,$30
            .byte $00,$03,$0C,$30,$0C,$03,$00,$00
            .byte $00,$00,$3F,$00,$00,$3F,$00,$00
            .byte $3C,$3C,$3C,$3C,$3C,$3C,$3C,$3C
            .byte $00,$00,$FF,$FF,$FF,$FF,$00,$00
            .byte $55,$55,$55,$55,$55,$55,$55,$55
            .byte $00,$3F,$33,$33,$3F,$33,$33,$00
            .byte $00,$3F,$33,$3F,$33,$33,$3F,$00
            .byte $00,$3F,$33,$30,$30,$33,$3F,$00
            .byte $00,$3C,$33,$33,$33,$33,$3C,$00
            .byte $00,$3F,$30,$3C,$30,$30,$3F,$00
            .byte $00,$3F,$30,$3C,$30,$30,$30,$00
            .byte $00,$3F,$33,$30,$30,$3F,$3F,$03
            .byte $00,$33,$33,$3F,$33,$33,$33,$00
            .byte $00,$3F,$0C,$0C,$0C,$0C,$3F,$00
            .byte $00,$03,$03,$03,$03,$33,$3F,$00
            .byte $00,$33,$33,$3C,$3C,$33,$33,$00
            .byte $00,$30,$30,$30,$30,$30,$3F,$00
            .byte $00,$33,$3F,$3F,$33,$33,$33,$00
            .byte $00,$3F,$33,$33,$33,$33,$33,$00
            .byte $00,$0C,$33,$33,$33,$33,$0C,$00
            .byte $00,$3F,$33,$3F,$30,$30,$30,$00
            .byte $00,$0C,$33,$33,$33,$33,$0C,$03
            .byte $00,$3F,$33,$3F,$3C,$33,$33,$00
            .byte $00,$3F,$30,$3F,$03,$03,$3F,$00
            .byte $00,$3F,$0C,$0C,$0C,$0C,$0C,$00
            .byte $00,$33,$33,$33,$33,$33,$3F,$00
            .byte $00,$33,$33,$33,$33,$3F,$0C,$00
            .byte $00,$33,$33,$33,$3F,$3F,$33,$00
            .byte $00,$33,$33,$0C,$0C,$33,$33,$00
            .byte $00,$33,$33,$3F,$0C,$0C,$0C,$00
;
            *= $4000
;
            .byte $2A,$2A,$2A,$2A,$2A,$2A,$2A,$2A
            .byte $2A,$2A,$2A,$2A,$2A,$2A,$2A,$2A
            .byte $2A,$2A,$2A,$2A,$2A,$2A,$2A,$2A
            .byte $2A,$2A,$2A,$2A,$2A,$2A,$20,$20
            .byte $20,$20,$20,$20,$2B,$20,$20,$20
            .byte $2B,$20,$20,$20,$2B,$20,$20,$20
            .byte $2B,$20,$20,$20,$2B,$20,$20,$20
            .byte $2B,$2A,$2A,$20,$2A,$20,$2A,$20
            .byte $2A,$20,$2A,$20,$2A,$20,$2A,$20
            .byte $2A,$20,$2A,$20,$2A,$20,$2A,$20
            .byte $2A,$20,$2A,$20,$2A,$20,$2A,$2A
            .byte $20,$2B,$20,$20,$20,$20,$2B,$20
            .byte $20,$20,$20,$2B,$20,$20,$20,$2B
            .byte $20,$20,$20,$20,$2B,$20,$20,$2B
            .byte $20,$20,$20,$2A,$2A,$20,$2A,$20
            .byte $2A,$20,$2A,$20,$2A,$2B,$2A,$20
            .byte $2A,$20,$2A,$20,$2A,$20,$2A,$20
            .byte $2A,$20,$2A,$20,$2A,$20,$2A,$20
            .byte $2A,$2A,$20,$2B,$20,$20,$20,$2B
            .byte $20,$20,$20,$2B,$20,$20,$20,$2B
            .byte $20,$20,$20,$2B,$20,$20,$20,$2B
            .byte $20,$20,$20,$2B,$20,$2A,$2A,$20
            .byte $2A,$20,$2A,$2B,$2A,$20,$2A,$20
            .byte $2A,$20,$2A,$2B,$2A,$20,$2A,$20
            .byte $2A,$20,$2A,$2B,$2A,$20,$2A,$20
            .byte $2A,$20,$2A,$2A,$2B,$20,$20,$2B
            .byte $20,$20,$2B,$20,$20,$2B,$20,$20
            .byte $2B,$20,$20,$2B,$20,$20,$2B,$20
            .byte $20,$2B,$20,$20,$2B,$20,$20,$2A
            .byte $2A,$20,$2A,$2B,$2A,$20,$2A,$2B
            .byte $2A,$20,$2A,$2B,$2A,$2B,$2A,$2B
            .byte $2A,$20,$2A,$2B,$2A,$2B,$2A,$20
            .byte $2A,$20,$2A,$20,$2A,$2A,$20,$20
            .byte $20,$20,$2B,$20,$20,$20,$2B,$20
            .byte $20,$20,$2B,$20,$20,$20,$2B,$20
            .byte $20,$20,$2B,$20,$20,$20,$2B,$20
            .byte $20,$2A,$2A,$2B,$2A,$20,$2A,$2B
            .byte $2A,$20,$2A,$2B,$2A,$20,$2A,$2B
            .byte $2A,$20,$2A,$2B,$2A,$20,$2A,$2B
            .byte $2A,$20,$2A,$2B,$2A,$20,$2A,$2A
            .byte $20,$20,$2B,$20,$2B,$20,$20,$20
            .byte $2B,$20,$2B,$20,$20,$20,$2B,$20
            .byte $2B,$20,$20,$20,$2B,$20,$20,$20
            .byte $20,$20,$20,$2A,$2A,$20,$2A,$20
            .byte $2A,$20,$2A,$20,$2A,$20,$2A,$20
            .byte $2A,$20,$2A,$20,$2A,$20,$2A,$20
            .byte $2A,$20,$2A,$2B,$2A,$20,$2A,$20
            .byte $2A,$2A,$2B,$20,$20,$20,$20,$2B
            .byte $20,$20,$2B,$20,$20,$20,$20,$20
            .byte $2B,$20,$20,$2B,$20,$20,$2B,$20
            .byte $20,$2B,$20,$20,$20,$2A,$2A,$20
            .byte $2A,$20,$2A,$20,$2A,$2B,$2A,$20
            .byte $2A,$20,$2A,$20,$2A,$20,$2A,$2B
            .byte $2A,$20,$2A,$20,$2A,$20,$2A,$20
            .byte $2A,$20,$2A,$2A,$20,$2B,$20,$20
            .byte $20,$2B,$20,$20,$20,$2B,$20,$20
            .byte $20,$2B,$20,$20,$20,$2B,$20,$20
            .byte $20,$2B,$20,$20,$20,$2B,$20,$2A
            .byte $2A,$20,$2A,$20,$2A,$20,$2A,$20
            .byte $2A,$20,$2A,$20,$2A,$2B,$2A,$20
            .byte $2A,$20,$2A,$20,$2A,$20,$2A,$20
            .byte $2A,$20,$2A,$20,$2A,$2A,$2B,$20
            .byte $20,$2B,$20,$20,$20,$2B,$20,$20
            .byte $20,$20,$2B,$20,$20,$20,$20,$20
            .byte $20,$2B,$20,$20,$2B,$20,$20,$20
            .byte $2B,$2A,$2A,$20,$2A,$2B,$2A,$20
            .byte $2A,$2B,$2A,$20,$2A,$2B,$2A,$20
            .byte $2A,$2B,$2A,$2B,$2A,$20,$2A,$2B
            .byte $2A,$20,$2A,$2B,$2A,$20,$2A,$2A
            .byte $20,$20,$20,$2B,$20,$20,$20,$2B
            .byte $20,$20,$20,$2B,$20,$20,$20,$2B
            .byte $20,$20,$2B,$20,$20,$20,$20,$2B
            .byte $20,$20,$20,$2A,$2A,$20,$2A,$20
            .byte $2A,$20,$2A,$20,$2A,$2B,$2A,$20
            .byte $2A,$20,$2A,$20,$2A,$20,$2A,$20
            .byte $2A,$2B,$2A,$20,$2A,$20,$2A,$20
            .byte $2A,$2A,$2B,$20,$2B,$20,$20,$20
            .byte $20,$20,$20,$20,$2B,$20,$20,$20
            .byte $20,$2B,$20,$20,$20,$2B,$20,$20
            .byte $2B,$20,$20,$20,$2B,$2A,$2A,$2A
            .byte $2A,$2A,$2A,$2A,$2A,$2A,$2A,$2A
            .byte $2A,$2A,$2A,$2A,$2A,$2A,$2A,$2A
            .byte $2A,$2A,$2A,$2A,$2A,$2A,$2A,$2A
            .byte $2A,$2A,$2A,$2A,$2A,$2A,$2A,$2A
            .byte $2A,$2A,$2A,$2A,$2A,$2A,$2A,$2A
            .byte $2A,$2A,$2A,$2A,$2A,$2A,$2A,$2A
            .byte $2A,$2A,$2A,$2A,$2A,$2A,$2A,$2A
            .byte $2A,$20,$20,$20,$20,$20,$2A,$20
            .byte $2B,$20,$20,$20,$2B,$20,$2A,$20
            .byte $2B,$20,$20,$20,$2B,$20,$2A,$20
            .byte $2B,$20,$20,$20,$2A,$2A,$20,$2A
            .byte $20,$2A,$20,$2B,$20,$2A,$20,$2A
            .byte $20,$2A,$20,$2B,$20,$2A,$20,$2A
            .byte $20,$2A,$20,$2B,$20,$2A,$20,$2A
            .byte $20,$2A,$2A,$2B,$2A,$20,$2A,$20
            .byte $2A,$20,$2A,$2B,$2A,$2B,$2A,$2A
            .byte $20,$2A,$2A,$2B,$2A,$2B,$2A,$20
            .byte $2A,$20,$2A,$20,$2A,$2B,$2A,$2A
            .byte $20,$20,$2B,$20,$2B,$2A,$20,$2B
            .byte $20,$2A,$20,$20,$2B,$20,$2B,$20
            .byte $20,$2A,$20,$2B,$20,$2A,$2B,$20
            .byte $2B,$20,$20,$2A,$2A,$20,$2A,$2A
            .byte $2A,$2A,$2A,$20,$2A,$2A,$2A,$2A
            .byte $2A,$20,$2A,$20,$2A,$2A,$2A,$2A
            .byte $2A,$20,$2A,$2A,$2A,$2A,$2A,$20
            .byte $2A,$2A,$20,$2B,$20,$20,$20,$20
            .byte $2B,$20,$2B,$2A,$2B,$20,$20,$2B
            .byte $20,$20,$2B,$2A,$2B,$20,$2B,$20
            .byte $20,$20,$20,$2B,$20,$2A,$2A,$2A
            .byte $2A,$2A,$2A,$2A,$2A,$20,$2A,$20
            .byte $2A,$20,$2A,$20,$2A,$20,$2A,$20
            .byte $2A,$20,$2A,$20,$2A,$2A,$2A,$2A
            .byte $2A,$2A,$2A,$2A,$20,$2B,$20,$20
            .byte $20,$20,$20,$2B,$20,$20,$20,$2A
            .byte $20,$2B,$20,$2A,$20,$20,$20,$2B
            .byte $20,$20,$20,$20,$20,$2B,$20,$2A
            .byte $2A,$2B,$2A,$2A,$2A,$20,$2A,$2A
            .byte $2A,$2A,$2A,$2A,$2A,$20,$2A,$20
            .byte $2A,$2A,$2A,$2A,$2A,$2A,$2A,$20
            .byte $2A,$2A,$2A,$2B,$2A,$2A,$20,$2A
            .byte $20,$20,$20,$2B,$20,$20,$2B,$20
            .byte $2B,$2A,$20,$2B,$20,$2A,$2B,$20
            .byte $2B,$20,$20,$2B,$20,$20,$20,$2A
            .byte $20,$2A,$2A,$2B,$2A,$2B,$2A,$2B
            .byte $2A,$20,$2A,$2B,$2A,$20,$2B,$20
            .byte $2A,$20,$2B,$20,$2A,$2B,$2A,$20
            .byte $2A,$2B,$2A,$2B,$2A,$2B,$2A,$2A
            .byte $20,$2A,$20,$2A,$20,$2A,$20,$2A
            .byte $20,$2A,$2A,$2A,$2A,$2A,$2A,$2A
            .byte $2A,$2A,$20,$2A,$20,$2A,$20,$2A
            .byte $20,$2A,$20,$2A,$2A,$2B,$2A,$2B
            .byte $2A,$20,$2A,$2B,$2A,$20,$2B,$20
            .byte $2B,$20,$20,$20,$2B,$20,$2B,$20
            .byte $2A,$2B,$2A,$20,$2A,$2B,$2A,$2B
            .byte $2A,$2A,$20,$2A,$20,$2A,$20,$2A
            .byte $20,$2A,$2A,$20,$2A,$20,$2A,$2A
            .byte $2A,$20,$2A,$20,$2A,$2A,$20,$2A
            .byte $20,$2A,$20,$2A,$20,$2A,$2A,$2B
            .byte $20,$20,$20,$2B,$2A,$2B,$20,$20
            .byte $2B,$2A,$20,$20,$2B,$20,$20,$2A
            .byte $2B,$20,$20,$2B,$2A,$2B,$20,$20
            .byte $20,$2B,$2A,$2A,$20,$2A,$2A,$2A
            .byte $20,$2A,$20,$2A,$2A,$20,$2A,$20
            .byte $2A,$2A,$2A,$20,$2A,$20,$2A,$2A
            .byte $20,$2A,$20,$2A,$2A,$2A,$20,$2A
            .byte $2A,$2B,$20,$20,$2A,$20,$2A,$20
            .byte $2A,$20,$2B,$2A,$2B,$20,$2B,$20
            .byte $2B,$2A,$2B,$20,$2A,$20,$2A,$20
            .byte $2A,$20,$20,$2B,$2A,$2A,$20,$2A
            .byte $2B,$2A,$20,$2A,$2B,$2A,$20,$2A
            .byte $2A,$20,$2A,$2A,$2A,$20,$2A,$2A
            .byte $20,$2A,$2B,$2A,$20,$2A,$2B,$2A
            .byte $20,$2A,$2A,$2B,$2A,$20,$2A,$2B
            .byte $20,$20,$2A,$2B,$2A,$20,$2B,$20
            .byte $2A,$20,$2B,$20,$2A,$2B,$2A,$20
            .byte $20,$2B,$2A,$20,$2A,$2B,$2A,$2A
            .byte $20,$2A,$20,$2A,$2A,$2A,$2A,$2A
            .byte $20,$2A,$20,$2A,$2B,$2A,$2B,$2A
            .byte $20,$2A,$20,$2A,$2A,$2A,$2A,$2A
            .byte $20,$2A,$20,$2A,$2A,$20,$2B,$20
            .byte $2B,$20,$20,$20,$2B,$20,$2B,$20
            .byte $2A,$20,$2B,$20,$2A,$20,$2B,$20
            .byte $2B,$20,$20,$20,$2B,$20,$2B,$20
            .byte $2A,$2A,$2A,$2A,$2A,$2A,$2A,$2A
            .byte $2A,$2A,$2A,$2A,$2A,$2A,$2A,$2A
            .byte $2A,$2A,$2A,$2A,$2A,$2A,$2A,$2A
            .byte $2A,$2A,$2A,$2A,$2A,$2A,$2A,$2A
            .byte $2A,$2A,$2A,$2A,$2A,$2A,$2A,$2A
            .byte $2A,$2A,$2A,$2A,$2A,$2A,$2A,$2A
            .byte $2A,$2A,$2A,$2A,$2A,$2A,$2A,$2A
            .byte $2A,$2A,$2A,$2A,$20,$20,$20,$20
            .byte $20,$2B,$20,$20,$20,$2B,$20,$2B
            .byte $20,$20,$20,$2B,$20,$2B,$20,$20
            .byte $20,$2B,$20,$2B,$20,$20,$20,$2A
            .byte $2A,$20,$2A,$2A,$2A,$2A,$2A,$20
            .byte $2A,$20,$2A,$20,$2A,$20,$2A,$20
            .byte $2A,$20,$2A,$20,$2A,$20,$2A,$2A
            .byte $2A,$2A,$2A,$20,$2A,$2A,$20,$2B
            .byte $20,$2B,$20,$2A,$2B,$2A,$2B,$2A
            .byte $2B,$2A,$2B,$2A,$2B,$2A,$20,$2A
            .byte $2B,$2A,$20,$2A,$20,$2B,$20,$2B
            .byte $20,$2A,$2A,$2B,$2A,$20,$2A,$20
            .byte $2B,$20,$2A,$20,$2A,$20,$2B,$20
            .byte $2B,$20,$2B,$20,$2A,$20,$2A,$2B
            .byte $20,$20,$2A,$20,$2A,$2B,$2A,$2A
            .byte $20,$2A,$2B,$2A,$20,$2A,$2A,$2A
            .byte $2B,$2A,$20,$2A,$2A,$2A,$2A,$2A
            .byte $20,$2A,$2B,$2A,$2A,$2A,$20,$2A
            .byte $2B,$2A,$20,$2A,$2A,$2B,$20,$20
            .byte $2A,$20,$20,$2B,$20,$20,$2A,$2B
            .byte $20,$20,$2B,$20,$20,$2B,$2A,$20
            .byte $20,$2B,$20,$20,$2A,$20,$20,$2B
            .byte $2A,$2A,$20,$2A,$2A,$2A,$2B,$2A
            .byte $2B,$2A,$2A,$2A,$2A,$2A,$2B,$2A
            .byte $2B,$2A,$2A,$2A,$2A,$2A,$2B,$2A
            .byte $2B,$2A,$2A,$2A,$20,$2A,$2A,$20
            .byte $2B,$20,$20,$20,$2A,$20,$2B,$20
            .byte $2B,$2A,$2B,$20,$20,$20,$2B,$2A
            .byte $2B,$20,$2B,$20,$2A,$20,$20,$20
            .byte $2B,$20,$2A,$2A,$2B,$2A,$2A,$2A
            .byte $2A,$2A,$20,$2A,$2A,$20,$2A,$20
            .byte $2A,$2A,$2A,$20,$2A,$20,$2A,$2A
            .byte $20,$2A,$2A,$2A,$2A,$2A,$2B,$2A
            .byte $2A,$20,$2B,$20,$20,$20,$20,$2B
            .byte $20,$2A,$2B,$20,$20,$20,$2B,$20
            .byte $20,$20,$2B,$2A,$20,$2B,$20,$20
            .byte $20,$20,$2B,$20,$2A,$2A,$2A,$2A
            .byte $2A,$2A,$2A,$2A,$2A,$20,$2A,$20
            .byte $2A,$2A,$2A,$2A,$2A,$2A,$2A,$20
            .byte $2A,$20,$2A,$2A,$2A,$2A,$2A,$2A
            .byte $2A,$2A,$2A,$20,$2B,$20,$20,$20
            .byte $2B,$20,$20,$2A,$20,$2B,$20,$2B
            .byte $20,$2B,$20,$2B,$20,$2A,$20,$2B
            .byte $20,$20,$20,$2B,$20,$20,$2A,$2A
            .byte $20,$2A,$2A,$2A,$2A,$2A,$2A,$20
            .byte $2A,$20,$2A,$20,$2A,$20,$2A,$20
            .byte $2A,$20,$2A,$20,$2A,$2A,$2A,$2A
            .byte $2A,$2A,$20,$2A,$2A,$2B,$2A,$20
            .byte $20,$20,$20,$2A,$2B,$2A,$20,$2A
            .byte $20,$2A,$2B,$2A,$20,$2A,$20,$2A
            .byte $2B,$2A,$20,$20,$20,$20,$2A,$2B
            .byte $2A,$2A,$20,$20,$2B,$2A,$2A,$2B
            .byte $20,$20,$20,$20,$2A,$2B,$20,$20
            .byte $20,$2B,$2A,$20,$20,$20,$20,$2B
            .byte $2A,$2A,$2B,$20,$20,$2A,$2A,$20
            .byte $2A,$2A,$2A,$20,$20,$2A,$2A,$2A
            .byte $2B,$2A,$20,$2A,$2A,$2A,$20,$2A
            .byte $2B,$2A,$2A,$2A,$20,$20,$2A,$2A
            .byte $2A,$20,$2A,$2A,$20,$20,$2B,$2A
            .byte $20,$2A,$2A,$2B,$20,$20,$20,$2B
            .byte $20,$2B,$20,$2B,$20,$20,$20,$2B
            .byte $2A,$2A,$20,$2A,$2B,$20,$20,$2A
            .byte $2A,$2B,$2A,$20,$2A,$2B,$20,$20
            .byte $20,$2A,$20,$2A,$2A,$2A,$20,$2A
            .byte $2A,$2A,$20,$2A,$20,$20,$20,$2B
            .byte $2A,$20,$2A,$2B,$2A,$2A,$20,$2A
            .byte $20,$2B,$20,$2A,$20,$2A,$2A,$2B
            .byte $2A,$20,$2B,$20,$2B,$20,$2A,$2B
            .byte $2A,$2A,$20,$2A,$20,$2B,$20,$2A
            .byte $20,$2A,$2A,$20,$2A,$2A,$2A,$2A
            .byte $2A,$2B,$2A,$20,$20,$20,$2B,$2A
            .byte $2A,$2A,$2B,$20,$20,$20,$2A,$2B
            .byte $2A,$2A,$2A,$2A,$2A,$20,$2A,$2A
            .byte $2B,$20,$20,$20,$20,$20,$20,$20
            .byte $2B,$2A,$2A,$20,$20,$2B,$20,$20
            .byte $2A,$2A,$2B,$20,$20,$20,$20,$20
            .byte $20,$20,$2B,$2A,$2A,$2A,$2A,$2A
            .byte $2A,$2A,$2A,$2A,$2A,$2A,$2A,$2A
            .byte $2A,$2A,$2A,$2A,$2A,$2A,$2A,$2A
            .byte $2A,$2A,$2A,$2A,$2A,$2A,$2A,$2A
            .byte $2A
L47D1       .word $4000,$429B,$4000,$4536
            .byte $7D,$20,$20,$20,$20,$20,$20,$20
            .byte $20,$20,$20,$20,$20,$20,$D3,$CC
            .byte $C9,$D4,$C8,$C5,$D2,$20,$20,$20
            .byte $20,$20,$20,$20,$20,$20,$20,$20
            .byte $20,$20,$20,$53,$20,$50,$45,$41
            .byte $52,$53,$4F,$4E,$20,$20,$20,$20
            .byte $20,$20,$26,$20,$20,$20,$20,$20
            .byte $20,$20,$50,$20,$4B,$4F,$48,$55
            .byte $54,$20,$20,$20,$20,$20,$20,$20
            .byte $20,$20,$20,$20,$20,$20,$20,$20
            .byte $20,$D3,$C3,$CF,$D2,$C5,$20,$20
            .byte $20,$20,$20,$20,$20,$20,$20,$20
            .byte $20,$20,$20,$20,$20,$20,$20,$30
            .byte $30,$30,$30,$30,$20,$20,$20,$20
            .byte $20,$20,$20,$20,$20,$20,$20,$20
            .byte $20,$20,$20,$20,$54,$49,$4D,$45
            .byte $20,$30,$30,$20,$20,$20,$20,$20
            .byte $20,$20,$20,$20,$20,$20,$20,$20
            .byte $20,$4C,$45,$56,$45,$4C,$20,$30
            .byte $30,$30,$20,$20,$20,$4C,$49,$56
            .byte $45,$53,$20,$34,$20,$20,$20,$20
            .byte $20,$20,$20,$20,$20,$20,$20,$20
            .byte $20,$20,$20,$20,$20,$20,$20,$20
            .byte $20,$20,$20,$20,$20,$28,$43,$29
            .byte $20,$31,$39,$38,$35,$20,$20,$20
            .byte $20,$41,$4E,$41,$4C,$4F,$47,$20
            .byte $20,$20,$20,$20,$20,$20,$20,$20
            .byte $20,$20,$20,$20,$20,$20,$20,$20
            .byte $20,$20,$20,$20,$20,$20,$20,$20
;
            *= $02E2
;
            .word L3500
;
         
