	device zxspectrum128
        ORG #6000
begin
;definitions
empty=0
wall=1
pill=2
head=3
body=4
	xor a:out ($FE),a

charp=$B700;characters+colors
snxy=$A000; snake coords,max 1024 1st -X, 2nd - Y
;font preparation
	ld hl,charp
;draw atributes
dra:
	ld (hl),$47
	inc l
	jr nz,dra
	inc h

	ld de,tiles
	ld c,5
dt1:
	ld b,8
	push hl
dt2:
	ld a,(de),(hl),a
	inc de,h
	djnz dt2
	pop hl
	inc l
	dec c
	jr nz,dt1
	ld hl,tcol,de,charp,bc,5:ldir

; MENU
	call blackscr
draw_title:
	ld hl,mnu1:call prm
	inc hl:call prm
	inc hl:call prm
	inc hl:call prm
	inc hl:call prm
	inc hl:call prm

menu_key:
;0
	ld a,$EF:in a,($FE):and 1:jp z,tune_params
;1
	ld a,$F7:in a,($FE):and 1:jp z,sound
;2
	ld a,$F7:in a,($FE):and 2:jp z,inert
	jr menu_key
sound:
p1: ld a,1
	inc a
	and 1
	ld (p1+1),a
	ld de,p1s
parbra:
	ld hl,t_on
	jr z,putstring
	ld hl,t_off
putstring:
	ldi:ldi
	call wp
	jp draw_title
inert:
p2: ld a,1
	inc a
	and 1
	ld (p2+1),a
	ld de,p2s
	jp parbra
tune_params:
; sound
	ld a,(p1+1)
	or a
	jr z,put_sound_op
	ld a,$C9
put_sound_op:
	ld (ay1),a
	ld (ay2),a
;inertia
;	jr $
	ld hl,1
	ld a,(p2+1)
	or a
	jr z,put_i_op
	dec hl
	ld a,$C9
put_i_op:
	xor $C9
	ld (reset_delta),a
	ld (initd+1),hl
startgame:
;lives=4
	ld a,4,(lives),a
;level=0
	xor a
	ld (lvl),a
;score=0
	ld (score),a,(score+1),a

game_begin:
	call drwlev
	call initd
	call drawstate
;start play
;	jr $
game_lp:
	ei:halt
	call move_snake
;keyscan
	xor a
	in a,($FE)
	cpl
	and 31
	jr z,no_press_key
	call check_keys
	jp game_lp
no_press_key:
	call reset_delta
	jp game_lp

;=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=
check_keys:
 ld a,$F7:in a,(#FE):and 16:jp z,left;5 is left
;O
 ld a,$DF:in a,(#FE):and 2:jp z,left

 ld a,$EF:in a,(#FE):and 4:jp z,right;8 is right
;P
 ld a,$DF:in a,(#FE):and 1:jp z,right

 ld a,$EF:in a,(#FE):and 8:jp z,up;7 is up
;Q
 ld a,$FB:in a,(#FE):and 1:jp z,up

 ld a,$EF:in a,(#FE):and 16:jp z,down;6 is down
;A
 ld a,$FD:in a,(#FE):and 1:jp z,down
	ret
left:
	ld bc,$00FF
	jp putdelta
right:
	ld bc,$0001
	jp putdelta
up:
	ld bc,$FF00
	jp putdelta
down:
	ld bc,$0100
putdelta:

	ei:halt
	ld de,(sxy)
	ld a,d:add a,b:ld d,a
	ld a,e:add a,c:ld e,a
	
	push bc
	ld l,d,h,0,b,h
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	ld c,e
	add hl,bc
	ld bc,$5800
	add hl,bc
	pop bc
	ld a,(hl)
	cp cwall:ret z

	ld (deltaxy+1),bc
	ret
;=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=
reset_delta:
;	ret
	nop; ret for inertia
rd2:
	ld hl,0,(deltaxy+1),hl
	ret
move_snake:
deltaxy:ld bc,$0001*0;BC=dy.dx
	ld de,(sxy)
	ld a,d:add a,b:ld d,a
	ld a,e:add a,c:ld e,a
	
	ld l,d,h,0,b,h
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	ld c,e
	add hl,bc
	ld bc,$5800
	add hl,bc
	ld a,(hl)
	cp cempty:jp z,empty_case
	;cp cwall:jp z,wall_case
	cp cpill:jp z,pill_case
	cp cbody:jp z,body_case
	ret
empty_case:
	ld (sxy),de
	jp pibra1
	ret

wall_case:
	ret;jp rd2
pill_case:
	ld (sxy),de
	ld hl,(sl)
	inc hl
	ld (sl),hl
	call ay2
;score++
	ld hl,(score)
	push de
	inc hl
	ld de,10000
	push hl
	or a:sbc hl,de
	pop hl
	jr c,no_life_plus
	ld hl,0
	ld a,(lives)
	inc a
	ld (lives),a
no_life_plus:
	ld (score),hl
	call drawstate
	pop de
pibra1:
	ld hl,(snp)
	inc hl
	res 2,h ; bound for 1024
;	ld a,h
;	cp 4+snxy/256
;	jr nz,no_bound
;no_bound:
	ld (snp),hl
	ld (hl),e
	inc h,h,h,h
	ld (hl),d
	call draws
	ei:halt
;test for pills
	ld hl,$5800
test_p:
	ld a,(hl)
	cp cpill
	ret z
	inc hl
	ld a,h
	cp $5B
	jr nz, test_p
	ld a,(lvl)
	inc a
	and 3
	ld (lvl),a
	pop af
;	jr $
	call wp
	jp game_begin
;	ret
body_case:
	ld a,(lives)
	dec a
	ld (lives),a
	push af
	call drawstate
	pop af
	jp z,gameover
	call ay1
;erase snake
	ld d,0
er_y:
	ld e,0
er_x:
	ld l,d,h,0
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	ld c,e,b,0
	add hl,bc
	ld bc,$5800
	add hl,bc
	ld a,(hl)
	cp chead:jr z,erase
	cp cbody:jr z,erase
	jr nextxy
erase:
	ld a,empty:call chxy
nextxy:
	inc e
	ld a,e
	cp 29
	jp nz,er_x
	inc d
	ld a,d
	cp 23
	jp nz,er_y
	call initd
	call draws
	ret
gameover:
	ld hl,tgameover
	call prm

;	jr $
inp_key:
; N
	ld a,$7f:in a,($fe):and 8:jp z,0
	ld a,$df: in a,($FE):and 16:jr nz,inp_key
	pop af
	jp startgame
	jr $

initd:
	ld hl,0,(deltaxy+1),hl
	ld hl,1,(sl),hl

	ld hl,snxy+2
	ld (snp),hl
zm:
	ld (hl),0
	inc l:jr nz,zm
	inc h
	ld a,h
	cp $B0
	jr nz,zm

	ld de,$0103,(sxy),de
	ld a,e,(snxy+2),a
	ld a,d,(snxy+1024+2),a
;	ld a,head:call chxy

	ld de,$0102
	ld a,e,(snxy+1),a
	ld a,d,(snxy+1024+1),a
;	ld a,body:call chxy
;rest of
	ld a,1,(snxy),a,(snxy+1024),a
	call draws
	ret
;;;;;;;;;;;;;;;;;; V A R S ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
score: dw 0
lives: db 4
lvl: db 0
sxy:dw $0103;snake head coords
sl: dw 1;snake length
snp:dw snxy+2; index of coords
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;; P R O C E D U R E S ;;;;
wp: ;wait until pressed
	xor a
	in a,($FE)
	cpl
	and 31
	jr nz,wp
	ret
mnu1:
	dw $40E0+9-3
	db $44
	db "Slither ",$FF

	dw $40E0+9+8-3
	db $46
	db "Shiny",$FF

	dw $40E0+9+8+6-3
	db $43
	db "2018",$FF

	dw $4820+9
	db $47
	db "1.Sounds:o"
p1s: db "ff"
	db $FF

	dw $4860+9
	db $47
	db "2.Inertia:o"
p2s: db "ff"
	db $FF

	dw $48A0+9
	db $47
	db "0.Start game",$FF

t_on: db "n "
t_off:db "ff"

tgameover:
 dw $4800+1+4*32 ; adr
 db $47 ; color
 db "Game Over. Play Again(Y/N)?",$FF;text

prm: ;HL=pointer at text
	ld e,(hl):inc hl
	ld d,(hl):inc hl
	ld a,(hl):inc hl
	ld (mec+1),a
	push de
	exx
	pop de
;convert address to atributes
;$40=010 00 000
;$48=010 01 000
;$50=010 10 000

;$58=010110 00
;$59=010110 01
;$5A=010110 10
	ld a,d
	and %000111000
	rra
	rra
	rra
	add a,$58
	ld h,a
	ld l,e
	exx
melp:
	exx
mec: ld (hl),0:inc hl
	exx
	ld a,(hl):inc hl
	push hl
	
	ld l,a,h,0
	add hl,hl
	add hl,hl
	add hl,hl
	ld bc,fnt-256
	add hl,bc
	push de
ch8lp:
	ld a,(hl),(de),a
	inc hl,d
	ld a,d
	and 7
	jr nz,ch8lp
	pop de
	inc e
	pop hl
	ld a,(hl)
	cp $FF
	jp nz,melp
	ret
ay1:
	nop
  LD            HL ,LE65A
LEEB1:
  LD            D ,(HL);EEB1
  LD            A ,D
  INC           A
  JR            Z ,LEEBE

  INC           HL
  LD            E ,(HL)
  INC           HL
  CALL          LED80
  JR            LEEB1

LEEBE:
  LD            D ,E ;EEBE
LEEBF:
  LD            A ,D ;EEBF
  RLA
  SLA           A
  SLL           A
  RRA
  ADD           A ,D
  OUT           (C) , A
  LD            HL ,$1388
LEECC:
  DEC           HL ;EECC
  LD            A ,H
  OR            L
  JR            NZ ,LEECC

  DEC           D
  JR            NZ ,LEEBF

  LD            DE ,$7FFF
  CALL          LED80
 ret
LED80:
	LD            BC ,$FFFD
	OUT           (C) , D
	LD            B ,$BF
	OUT           (C) , E
	RET
LE65A:
 db $07,$1F,$0A,$10,$0D,$01
 db $0B,$78,$0C,$1E,$06,$1F
 db $FF,$3E,$01,$D6,$04,$20
 db $07,$21,$A4,$E6,$35,$C0
 db $36,$03,$C3,$D6,$C0,$00

ay2:
	nop
	push hl,bc
		ld	hl, aydu1
		xor	a
ay2lp:
		ld	bc, 0FFFDh
		out	(c), a
		push	af
		ld	a, (hl)
		inc	hl
		ld	b, 0BFh
		out	(c), a
		pop	af
		inc	a
		cp	0Eh
		jr	nz, ay2lp
		pop bc,hl
		ret
aydu1:
		db  70h
		db    0
		db    5
		db    0
		db 0B0h
		db    0
		db    0
		db  38h
		db  10h
		db  10h
		db  10h
		db    0
		db  28h
		db    1
		db    0
		db    0
draws: ;draw snake
	ld hl,(snp)

	push hl
	ld e,(hl)
	inc h,h,h,h
	ld d,(hl)

	ld a,head:call chxy
	pop hl
	;dec hl
	call bound_hl
	ld bc,(sl)
ds_lp:
	push bc
	push hl

	ld e,(hl)
	inc h,h,h,h
	ld d,(hl)
	ld a,body:call chxy
	pop hl
	pop bc
	;dec hl
	call bound_hl
	dec bc
	ld a,b:or c:jr nz,ds_lp

	ld e,(hl)
	inc h,h,h,h
	ld d,(hl)
	ld a,empty:call chxy

	ret
bound_hl:
	dec hl
	ld a,h
	cp snxy/256-1
	ret nz
	ld hl,snxy+1024-1
	ret
drawstate:
; white attributes
	ld hl,$5Ae0
whitea:
	ld (hl),$06:inc l
	jr nz,whitea

	ld a,(lives)
	add a,"0"
	ld (live),a
	ld a,(lvl)
	add a,"0"
	ld (levn),a

;score
	ld hl,(score)
	ld ix,sco
	call DispHL
;put values
	ld hl,state
	ld de,$50E0
drst_lp:
	ld a,(hl):inc hl
	cp $FF
	ret z
	push hl
	
	ld l,a,h,0
	add hl,hl
	add hl,hl
	add hl,hl
	ld bc,fnt-256
	add hl,bc
	
	ld b,8
	push de
ch8:
	ld a,(hl),(de),a
	inc hl,d
	djnz ch8
	pop de
	inc e
	pop hl
	jp drst_lp

;Number in hl to decimal ASCII
;Thanks to z80 Bits
;inputs:	hl = number to ASCII
;example: hl=300 outputs '00300'
;destroys: af, bc, hl, de used
DispHL:
;	ld	bc,-10000
;	call	Num1
	ld	bc,-1000
	call	Num1
	ld	bc,-100
	call	Num1
	ld	c,-10
	call	Num1
	ld	c,-1
Num1:	ld	a,'0'-1
Num2:	inc	a
	add	hl,bc
	jr	c,Num2
	sbc	hl,bc
	ld (ix+0),a:inc ix
	ret 

state:
 db "  LIVES:"
live: db "0"
 db " LVL:"
levn: db "0"
 db " SCORE:"
sco: db "0000"
	db $FF

lvlpoi:
	dw l1,l2,l1,l3
blackscr:
	ld hl,$5800,de,$5801,bc,767,(hl),l:ldir
	ret
drwlev:;drawtext,29x23
	call blackscr

	ld hl,(lvl)
	ld h,0
	add hl,hl
	ld de,lvlpoi
	add hl,de
	ld a,(hl):inc hl:ld h,(hl),l,a
	push hl
	pop ix;ld ix,l1
	ld d,0
ld_y:
	ld e,0
ld_x:
	ld a,(ix):inc ix
	ld c,wall:cp "*":jr z,putchar
	ld c,empty:cp " ":jr z,putchar
	ld c,pill:cp "+":jr z,putchar
	ld a,2:out ($FE),a
	jr $
putchar:
	ld a,c
	call chxy
	inc e
	ld a,e
	cp 29;+1
	jp nz,ld_x
	inc d
	ld a,d
	cp 23
	jp nz,ld_y
	ret

chxy:
;DE=y.x,A=#
	push de
		ld b,charp/256
		ld c,a
;atributes 1st
	push bc
	ld l,d,h,0
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	ld c,e,b,0
	add hl,bc
	ld bc,$5800
	add hl,bc
	pop bc
	ld a,(bc)
	inc b
	ld (hl),a
;character
		ld	hl, 4000h
		ld	a, d
		and	18h
		or	h
		ld	h, a
		ld	a, d
		and	7
		ld	d, a
		srl	d
		rr	l
		srl	d
		rr	l
		srl	d
		rr	l
		add	hl, de
 dup 8
 	ld a,(bc),(hl),a:inc b,h
edup
	pop de
	ret

tcol:
cempty=$47
cwall=2
cpill=5
chead=1+5*8
cbody=1
	db cempty,cwall,cpill,chead,cbody
tiles:
; empty
	ds 8
;wall
	db %00000000
	db %11011111
	db %11011111
	db %11011111
	db %00000000
	db %11111011
	db %11111011
	db %11111011

;	db %00000000
;	db %11101111
;	db %11101111
;	db %11101111
;	db %00000000
;	db %11111110
;	db %11111110
;	db %11111110
;pill
	db %00000000
	db %00000000
	db %00000000
	db %00111100
	db %00111100
	db %00111100
	db %00000000
	db %00000000

;head
	db %01111110
	db %11111111
	db %11111111
	db %11100111
	db %11100111
	db %11111111
	db %11111111
	db %01111110
;body
	db %01111110
	db %11111111
	db %11111111
	db %11111111
	db %11111111
	db %11111111
	db %11111111
	db %01111110
;tail?

;levels .word $4000,$429B,$4000,$4536
l1:incbin "l1.bin"
l2:incbin "l2.bin"
l3:incbin "l3.bin"
fnt:incbin "snake.fnt"
end
	display /d,end-begin
	display reset_delta
	savesna "!void.sna",begin
	savebin "slither.code",begin,end-begin
